#version 430 core

#include "global.inc"

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 uv0;

// Instance data
layout(location = 2) in vec3 particlePos;
layout(location = 3) in float particleScale;
layout(location = 4) in float particleAlpha;
layout(location = 5) in int particleColor;

#ifdef ANIMATED
	layout(location = 6) in int particleTexture;
#endif

out VertexOutput 
{
	float alpha;
	vec2 uv;
	vec4 clip;
	flat int color;

	#ifdef ANIMATED
		flat int texNr;
	#endif
} vertexOutput;

void main() {
	vertexOutput.alpha = particleAlpha;
	vertexOutput.uv = uv0;
	vertexOutput.color = particleColor;

	#ifdef ANIMATED
		vertexOutput.texNr = particleTexture;
	#endif

	mat4 temp = mat4(mat3(camera.eye));
	temp[3] = vec4(particlePos,1);
	mat4 mvp = camera.viewProjection * temp;

	vec4 pos =  mvp * vec4((position * particleScale),1);

	vertexOutput.clip = pos;
	
	gl_Position = pos;
}